

import random, struct, time
from pathlib import Path

def check_file_exists(file_path: Path):
    return file_path.is_file()

def waste_time_rand():
    time.sleep(random.randint(0, 3))

def waste_time(t: int):
    time.sleep(t)


def gen_binary_file(file_name: str, N: int):
    with open(file_name, 'wb') as f:
        for _ in range(N):
            f.write(struct.pack('f', random.uniform(-1000.0, 1000.0)))


def read_binary_file(file_name) -> list[float]:
    ret = []

    with open(file_name, 'rb') as f:
        while True:
            aux = f.read(4)
            if not aux:
                break
            ret.append(struct.unpack('f', aux)[0])

    return ret

def dec_measure(fun_name):
    def decorator(fun):
        def wrapper(*args, **kwargs):
            inicio = time.time()
            ret = fun(*args, **kwargs)
            fin = time.time()
            print(f"{fun_name}: {fin - inicio:.4f} s")
            return ret
        return wrapper
    return decorator

def dec_print(initial_msg):
    def decorator(fun):
        def wrapper(*args, **kwargs):
            print(initial_msg)
            fun(*args, **kwargs)
            print("Done")
        return wrapper
    return decorator